/*eslint-disable no-process-exit*/

'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

var _this = this;

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _config = require('../config');

var _helpers = require('../helpers');

var _logo = require('./logo');

var _logo2 = _interopRequireDefault(_logo);

var _util = require('./util');

var _core = require('../core');

var clc = (0, _helpers.cliColor)();

_commander2['default'].version(_config.version);

_commander2['default'].command('init [path]').description('Init your static website').action(function () {
    var path = arguments.length <= 0 || arguments[0] === undefined ? '.' : arguments[0];

    console.log(_logo2['default']);
    (0, _util.init)(path);
});

_commander2['default'].command('config [path]').description('Config your static website').action(function callee$0$0() {
    var path = arguments.length <= 0 || arguments[0] === undefined ? '.' : arguments[0];
    return _regeneratorRuntime.async(function callee$0$0$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                console.log(_logo2['default']);
                context$1$0.next = 3;
                return _regeneratorRuntime.awrap((0, _util.config)(path));

            case 3:
                console.log(clc.info('\nharmonic.json successfully updated.'));

            case 4:
            case 'end':
                return context$1$0.stop();
        }
    }, null, _this);
});

_commander2['default'].command('build [path]').description('Build your static website').action(function () {
    var path = arguments.length <= 0 || arguments[0] === undefined ? '.' : arguments[0];

    (0, _core.build)(path);
});

_commander2['default'].command('new_post <title> [path]').option('--no-open', 'Don\'t open the markdown file(s) in editor').description('Create a new post').action(function (title, path, _ref) {
    if (path === undefined) path = '.';
    var autoOpen = _ref.open;

    (0, _util.newFile)(path, 'post', title, autoOpen);
});

_commander2['default'].command('new_page <title> [path]').option('--no-open', 'Don\'t open the markdown file(s) in editor').description('Create a new page').action(function (title, path, _ref2) {
    if (path === undefined) path = '.';
    var autoOpen = _ref2.open;

    (0, _util.newFile)(path, 'page', title, autoOpen);
});

_commander2['default'].command('run [port] [path]').option('--no-open', 'Don\'t open a new browser window').description('Run you static site locally. Port is optional').action(function callee$0$0(port, path, _ref3) {
    if (port === undefined) port = 9356;
    if (path === undefined) path = '.';
    var autoOpen = _ref3.open;
    return _regeneratorRuntime.async(function callee$0$0$(context$1$0) {
        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                context$1$0.next = 2;
                return _regeneratorRuntime.awrap((0, _core.build)(path));

            case 2:
                (0, _util.run)(path, port, autoOpen);

            case 3:
            case 'end':
                return context$1$0.stop();
        }
    }, null, _this);
});

_commander2['default'].on('*', function (args) {
    console.error('Unknown command: ' + clc.error(args[0]));
    process.exit(1);
});

_commander2['default'].parse(process.argv);

// Not enough arguments
if (!_commander2['default'].args.length) {
    console.log(_logo2['default']);
    _commander2['default'].help();
}