'use strict';

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _Promise = require('babel-runtime/core-js/promise')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _prettyMs = require('pretty-ms');

var _prettyMs2 = _interopRequireDefault(_prettyMs);

var _helpers = require('./helpers');

var _parser = require('./parser');

var _parser2 = _interopRequireDefault(_parser);

var clc = (0, _helpers.cliColor)();

exports.build = build;

function build(passedPath) {
    var startTime, sitePath, harmonic, postsDataPromise, pagesDataPromise, endTime;
    return _regeneratorRuntime.async(function build$(context$1$0) {
        var _this = this;

        while (1) switch (context$1$0.prev = context$1$0.next) {
            case 0:
                startTime = Date.now();
                sitePath = (0, _helpers.findHarmonicRoot)(passedPath);

                if (sitePath) {
                    context$1$0.next = 5;
                    break;
                }

                (0, _helpers.displayNonInitializedFolderErrorMessage)();
                throw new _helpers.MissingFileError();

            case 5:
                harmonic = new _parser2['default'](sitePath, { quiet: false });
                context$1$0.next = 8;
                return _regeneratorRuntime.awrap(harmonic.clean());

            case 8:
                postsDataPromise = (function callee$1$0() {
                    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
                        while (1) switch (context$2$0.prev = context$2$0.next) {
                            case 0:
                                context$2$0.t0 = _regeneratorRuntime;
                                context$2$0.t1 = harmonic;
                                context$2$0.next = 4;
                                return _regeneratorRuntime.awrap(harmonic.getPostFiles());

                            case 4:
                                context$2$0.t2 = context$2$0.sent;
                                context$2$0.t3 = context$2$0.t1.generatePosts.call(context$2$0.t1, context$2$0.t2);
                                context$2$0.next = 8;
                                return context$2$0.t0.awrap.call(context$2$0.t0, context$2$0.t3);

                            case 8:
                                return context$2$0.abrupt('return', context$2$0.sent);

                            case 9:
                            case 'end':
                                return context$2$0.stop();
                        }
                    }, null, _this);
                })();

                pagesDataPromise = (function callee$1$0() {
                    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
                        while (1) switch (context$2$0.prev = context$2$0.next) {
                            case 0:
                                context$2$0.t0 = _regeneratorRuntime;
                                context$2$0.t1 = harmonic;
                                context$2$0.next = 4;
                                return _regeneratorRuntime.awrap(harmonic.getPageFiles());

                            case 4:
                                context$2$0.t2 = context$2$0.sent;
                                context$2$0.t3 = context$2$0.t1.generatePages.call(context$2$0.t1, context$2$0.t2);
                                context$2$0.next = 8;
                                return context$2$0.t0.awrap.call(context$2$0.t0, context$2$0.t3);

                            case 8:
                                return context$2$0.abrupt('return', context$2$0.sent);

                            case 9:
                            case 'end':
                                return context$2$0.stop();
                        }
                    }, null, _this);
                })();

                context$1$0.next = 12;
                return _regeneratorRuntime.awrap(_Promise.all([harmonic.compileCSS(), (function callee$1$0() {
                    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
                        while (1) switch (context$2$0.prev = context$2$0.next) {
                            case 0:
                                context$2$0.t0 = _regeneratorRuntime;
                                context$2$0.t1 = harmonic;
                                context$2$0.next = 4;
                                return _regeneratorRuntime.awrap(postsDataPromise);

                            case 4:
                                context$2$0.t2 = context$2$0.sent;
                                context$2$0.next = 7;
                                return _regeneratorRuntime.awrap(pagesDataPromise);

                            case 7:
                                context$2$0.t3 = context$2$0.sent;
                                context$2$0.t4 = context$2$0.t1.generateIndex.call(context$2$0.t1, context$2$0.t2, context$2$0.t3);
                                context$2$0.next = 11;
                                return context$2$0.t0.awrap.call(context$2$0.t0, context$2$0.t4);

                            case 11:
                                return context$2$0.abrupt('return', context$2$0.sent);

                            case 12:
                            case 'end':
                                return context$2$0.stop();
                        }
                    }, null, _this);
                })(), (function callee$1$0() {
                    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
                        while (1) switch (context$2$0.prev = context$2$0.next) {
                            case 0:
                                context$2$0.t0 = _regeneratorRuntime;
                                context$2$0.t1 = harmonic;
                                context$2$0.next = 4;
                                return _regeneratorRuntime.awrap(postsDataPromise);

                            case 4:
                                context$2$0.t2 = context$2$0.sent;
                                context$2$0.t3 = context$2$0.t1.generateTagsPages.call(context$2$0.t1, context$2$0.t2);
                                context$2$0.next = 8;
                                return context$2$0.t0.awrap.call(context$2$0.t0, context$2$0.t3);

                            case 8:
                                return context$2$0.abrupt('return', context$2$0.sent);

                            case 9:
                            case 'end':
                                return context$2$0.stop();
                        }
                    }, null, _this);
                })(), (function callee$1$0() {
                    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
                        while (1) switch (context$2$0.prev = context$2$0.next) {
                            case 0:
                                context$2$0.t0 = _regeneratorRuntime;
                                context$2$0.t1 = harmonic;
                                context$2$0.next = 4;
                                return _regeneratorRuntime.awrap(postsDataPromise);

                            case 4:
                                context$2$0.t2 = context$2$0.sent;
                                context$2$0.next = 7;
                                return _regeneratorRuntime.awrap(pagesDataPromise);

                            case 7:
                                context$2$0.t3 = context$2$0.sent;
                                context$2$0.t4 = context$2$0.t1.compileJS.call(context$2$0.t1, context$2$0.t2, context$2$0.t3);
                                context$2$0.next = 11;
                                return context$2$0.t0.awrap.call(context$2$0.t0, context$2$0.t4);

                            case 11:
                                return context$2$0.abrupt('return', context$2$0.sent);

                            case 12:
                            case 'end':
                                return context$2$0.stop();
                        }
                    }, null, _this);
                })(), (function callee$1$0() {
                    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
                        while (1) switch (context$2$0.prev = context$2$0.next) {
                            case 0:
                                context$2$0.t0 = _regeneratorRuntime;
                                context$2$0.t1 = harmonic;
                                context$2$0.next = 4;
                                return _regeneratorRuntime.awrap(postsDataPromise);

                            case 4:
                                context$2$0.t2 = context$2$0.sent;
                                context$2$0.next = 7;
                                return _regeneratorRuntime.awrap(pagesDataPromise);

                            case 7:
                                context$2$0.t3 = context$2$0.sent;
                                context$2$0.t4 = context$2$0.t1.generateRSS.call(context$2$0.t1, context$2$0.t2, context$2$0.t3);
                                context$2$0.next = 11;
                                return context$2$0.t0.awrap.call(context$2$0.t0, context$2$0.t4);

                            case 11:
                                return context$2$0.abrupt('return', context$2$0.sent);

                            case 12:
                            case 'end':
                                return context$2$0.stop();
                        }
                    }, null, _this);
                })(), (function callee$1$0() {
                    return _regeneratorRuntime.async(function callee$1$0$(context$2$0) {
                        while (1) switch (context$2$0.prev = context$2$0.next) {
                            case 0:
                                context$2$0.next = 2;
                                return _regeneratorRuntime.awrap(harmonic.copyThemeResources());

                            case 2:
                                context$2$0.next = 4;
                                return _regeneratorRuntime.awrap(harmonic.copyUserResources());

                            case 4:
                            case 'end':
                                return context$2$0.stop();
                        }
                    }, null, _this);
                })()]));

            case 12:
                endTime = Date.now();

                console.log(clc.info('Build completed in ' + (0, _prettyMs2['default'])(endTime - startTime) + '.'));

            case 14:
            case 'end':
                return context$1$0.stop();
        }
    }, null, this);
}

// finish copying theme resources first to allow user resources to overwrite them.

// TODO move logging to outside of this API?