'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _toConsumableArray = require('babel-runtime/helpers/to-consumable-array')['default'];

var _slicedToArray = require('babel-runtime/helpers/sliced-to-array')['default'];

var _Object$values = require('babel-runtime/core-js/object/values')['default'];

var _Object$assign = require('babel-runtime/core-js/object/assign')['default'];

var _regeneratorRuntime = require('babel-runtime/regenerator')['default'];

var _Promise = require('babel-runtime/core-js/promise')['default'];

var _Object$entries = require('babel-runtime/core-js/object/entries')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _bluebird = require('bluebird');

var _nunjucks = require('nunjucks');

var _nunjucks2 = _interopRequireDefault(_nunjucks);

var _permalinks = require('permalinks');

var _permalinks2 = _interopRequireDefault(_permalinks);

var _markedMetadata = require('marked-metadata');

var _markedMetadata2 = _interopRequireDefault(_markedMetadata);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _ncp = require('ncp');

var _rimraf = require('rimraf');

var _rimraf2 = _interopRequireDefault(_rimraf);

var _stylus2 = require('stylus');

var _stylus3 = _interopRequireDefault(_stylus2);

var _less2 = require('less');

var _less3 = _interopRequireDefault(_less2);

var _config = require('./config');

var _helpers = require('./helpers');

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

(0, _bluebird.promisifyAll)(_fs2['default']);
var mkdirpAsync = (0, _bluebird.promisify)(_mkdirp2['default']);
var ncpAsync = (0, _bluebird.promisify)(_ncp.ncp);
var rimrafAsync = (0, _bluebird.promisify)(_rimraf2['default']);

var clc = (0, _helpers.cliColor)();
var rMarkdownExt = /\.(?:md|markdown)$/;

var Helper = {

    sort: function sort(a, b) {
        return new Date(b.date) - new Date(a.date);
    },

    sortPosts: function sortPosts(posts) {
        _Object$values(posts).forEach(function (postsArray) {
            return postsArray.sort(Helper.sort);
        });
        return posts;
    },

    normalizeMetaData: function normalizeMetaData(data) {
        data.title = data.title.replace(/\"/g, '');
        return data;
    },

    normalizeContent: function normalizeContent(data) {
        return data;
    }
};

var Harmonic = (function () {
    /*eslint-disable camelcase*/

    function Harmonic(sitePath) {
        var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

        var _ref$quiet = _ref.quiet;
        var quiet = _ref$quiet === undefined ? true : _ref$quiet;

        _classCallCheck(this, Harmonic);

        this.sitePath = _path2['default'].resolve(sitePath);
        this.quiet = !!quiet;

        var config = _Object$assign({
            index_posts: 10
        }, (0, _helpers.getConfig)(this.sitePath));
        this.theme = new _theme2['default'](config.theme, this.sitePath);

        if (_fs2['default'].existsSync(_path2['default'].join(this.theme.themePath, 'config.json'))) {
            _Object$assign(config, JSON.parse(this.theme.getFileContents('config.json')));
        }

        this.config = config;
        this.nunjucksEnv = _nunjucks2['default'].configure(this.theme.themePath, { watch: false });
    }

    _createClass(Harmonic, [{
        key: 'clean',
        value: function clean() {
            return _regeneratorRuntime.async(function clean$(context$2$0) {
                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        console.log(clc.warn('Cleaning up...'));
                        context$2$0.next = 3;
                        return _regeneratorRuntime.awrap(rimrafAsync(_path2['default'].join(this.sitePath, 'public'), { maxBusyTries: 20 }));

                    case 3:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }, {
        key: 'compileCSS',
        value: function compileCSS() {
            var currentCSSCompiler, compiler;
            return _regeneratorRuntime.async(function compileCSS$(context$2$0) {
                var _this = this;

                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        currentCSSCompiler = this.config.preprocessor;

                        if (currentCSSCompiler) {
                            context$2$0.next = 3;
                            break;
                        }

                        return context$2$0.abrupt('return');

                    case 3:
                        compiler = {

                            less: function less() {
                                var lessIndexPath, cssDir, lessInput, _ref2, css;

                                return _regeneratorRuntime.async(function less$(context$3$0) {
                                    while (1) switch (context$3$0.prev = context$3$0.next) {
                                        case 0:
                                            lessIndexPath = _path2['default'].join(this.theme.themePath, 'resources/_less/index.less');
                                            cssDir = _path2['default'].join(this.sitePath, 'public/css');
                                            context$3$0.next = 4;
                                            return _regeneratorRuntime.awrap(_fs2['default'].readFileAsync(lessIndexPath, { encoding: 'utf8' }));

                                        case 4:
                                            lessInput = context$3$0.sent;
                                            context$3$0.next = 7;
                                            return _regeneratorRuntime.awrap(_less3['default'].render(lessInput, { filename: lessIndexPath }));

                                        case 7:
                                            _ref2 = context$3$0.sent;
                                            css = _ref2.css;
                                            context$3$0.next = 11;
                                            return _regeneratorRuntime.awrap(mkdirpAsync(cssDir));

                                        case 11:
                                            context$3$0.next = 13;
                                            return _regeneratorRuntime.awrap(_fs2['default'].writeFileAsync(_path2['default'].join(cssDir, 'main.css'), css));

                                        case 13:

                                            console.log(clc.info('Successfully generated CSS with LESS preprocessor'));

                                        case 14:
                                        case 'end':
                                            return context$3$0.stop();
                                    }
                                }, null, _this);
                            },

                            stylus: function stylus() {
                                var stylDir, stylIndexPath, cssDir, stylInput, css;
                                return _regeneratorRuntime.async(function stylus$(context$3$0) {
                                    while (1) switch (context$3$0.prev = context$3$0.next) {
                                        case 0:
                                            stylDir = _path2['default'].join(this.theme.themePath, 'resources/_stylus');
                                            stylIndexPath = _path2['default'].join(stylDir, 'index.styl');
                                            cssDir = _path2['default'].join(this.sitePath, 'public/css');
                                            context$3$0.next = 5;
                                            return _regeneratorRuntime.awrap(_fs2['default'].readFileAsync(stylIndexPath, { encoding: 'utf8' }));

                                        case 5:
                                            stylInput = context$3$0.sent;
                                            context$3$0.next = 8;
                                            return _regeneratorRuntime.awrap((0, _bluebird.fromNode)(function (cb) {
                                                (0, _stylus3['default'])(stylInput).set('filename', stylIndexPath).set('paths', [_path2['default'].join(stylDir, 'engine'), _path2['default'].join(stylDir, 'partials')]).render(cb);
                                            }));

                                        case 8:
                                            css = context$3$0.sent;
                                            context$3$0.next = 11;
                                            return _regeneratorRuntime.awrap(mkdirpAsync(cssDir));

                                        case 11:
                                            context$3$0.next = 13;
                                            return _regeneratorRuntime.awrap(_fs2['default'].writeFileAsync(_path2['default'].join(cssDir, 'main.css'), css));

                                        case 13:

                                            console.log(clc.info('Successfully generated CSS with Stylus preprocessor'));

                                        case 14:
                                        case 'end':
                                            return context$3$0.stop();
                                    }
                                }, null, _this);
                            }
                        };

                        if (compiler.hasOwnProperty(currentCSSCompiler)) {
                            context$2$0.next = 6;
                            break;
                        }

                        throw new Error('Unsupported CSS preprocessor: ' + currentCSSCompiler);

                    case 6:
                        context$2$0.next = 8;
                        return _regeneratorRuntime.awrap(compiler[currentCSSCompiler]());

                    case 8:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }, {
        key: 'compileJS',
        value: function compileJS(postsMetadata, pagesMetadata) {
            var harmonicClient;
            return _regeneratorRuntime.async(function compileJS$(context$2$0) {
                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        context$2$0.next = 2;
                        return _regeneratorRuntime.awrap(_fs2['default'].readFileAsync(_config.rootdir + '/bin/client/harmonic-client.js', { encoding: 'utf8' }));

                    case 2:
                        context$2$0.t0 = JSON.stringify(postsMetadata);
                        context$2$0.t1 = JSON.stringify(pagesMetadata);
                        context$2$0.t2 = JSON.stringify(this.config);
                        harmonicClient = context$2$0.sent.replace(/__HARMONIC\.POSTS__/g, context$2$0.t0).replace(/__HARMONIC\.PAGES__/g, context$2$0.t1).replace(/__HARMONIC\.CONFIG__/g, context$2$0.t2);
                        context$2$0.next = 8;
                        return _regeneratorRuntime.awrap(_fs2['default'].writeFileAsync(_path2['default'].join(this.sitePath, 'public/harmonic.js'), harmonicClient));

                    case 8:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }, {
        key: 'generateTagsPages',
        value: function generateTagsPages(postsMetadata) {
            var _ref3;

            var tagTemplateNJ, config;
            return _regeneratorRuntime.async(function generateTagsPages$(context$2$0) {
                var _this2 = this;

                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        tagTemplateNJ = _nunjucks2['default'].compile(this.theme.getFileContents('index.html'), this.nunjucksEnv);
                        config = this.config;
                        context$2$0.next = 4;
                        return _regeneratorRuntime.awrap(_Promise.all((_ref3 = []).concat.apply(_ref3, _toConsumableArray(_Object$entries(postsMetadata).map(function (_ref4) {
                            var _ref42 = _slicedToArray(_ref4, 2);

                            var lang = _ref42[0];
                            var langPosts = _ref42[1];

                            var postsByTag = {};
                            langPosts.forEach(function (post) {
                                post.categories.forEach(function (category) {
                                    // TODO replace with kebabCase?
                                    var tag = category.toLowerCase().trim().split(' ').join('-');
                                    postsByTag[tag] = postsByTag[tag] || [];
                                    postsByTag[tag].push(post);
                                });
                            });

                            return _Object$entries(postsByTag).map(function callee$3$0(_ref5) {
                                var _ref52 = _slicedToArray(_ref5, 2);

                                var tag = _ref52[0];
                                var tagPosts = _ref52[1];
                                var tagContent, tagPath;
                                return _regeneratorRuntime.async(function callee$3$0$(context$4$0) {
                                    while (1) switch (context$4$0.prev = context$4$0.next) {
                                        case 0:
                                            tagContent = tagTemplateNJ.render({
                                                posts: tagPosts,
                                                config: config,
                                                category: tag
                                            });
                                            tagPath = _path2['default'].join.apply(_path2['default'], [this.sitePath, 'public/categories'].concat(_toConsumableArray(config.i18n['default'] === lang ? [] : [lang]), [tag]));
                                            context$4$0.next = 4;
                                            return _regeneratorRuntime.awrap(mkdirpAsync(tagPath));

                                        case 4:
                                            context$4$0.next = 6;
                                            return _regeneratorRuntime.awrap(_fs2['default'].writeFileAsync(_path2['default'].join(tagPath, 'index.html'), tagContent));

                                        case 6:
                                            console.log(clc.info('Successfully generated tag[' + tag + '] archive html file'));

                                        case 7:
                                        case 'end':
                                            return context$4$0.stop();
                                    }
                                }, null, _this2);
                            });
                        })))));

                    case 4:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }, {
        key: 'generateIndex',
        value: function generateIndex(postsMetadata, pagesMetadata) {
            var indexTemplateNJ, config;
            return _regeneratorRuntime.async(function generateIndex$(context$2$0) {
                var _this3 = this;

                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        indexTemplateNJ = _nunjucks2['default'].compile(this.theme.getFileContents('index.html'), this.nunjucksEnv);
                        config = this.config;
                        context$2$0.next = 4;
                        return _regeneratorRuntime.awrap(_Promise.all(_Object$entries(postsMetadata).map(function callee$2$0(_ref6) {
                            var _ref62 = _slicedToArray(_ref6, 2);

                            var lang = _ref62[0];
                            var langPosts = _ref62[1];
                            var posts, pages, indexContent, indexPath;
                            return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
                                while (1) switch (context$3$0.prev = context$3$0.next) {
                                    case 0:
                                        posts = langPosts.slice(0, config.index_posts);
                                        pages = pagesMetadata[lang] || [];
                                        indexContent = indexTemplateNJ.render({
                                            posts: posts,
                                            pages: pages,
                                            config: config
                                        });
                                        indexPath = _path2['default'].join.apply(_path2['default'], [this.sitePath, 'public'].concat(_toConsumableArray(config.i18n['default'] === lang ? [] : [lang])));
                                        context$3$0.next = 6;
                                        return _regeneratorRuntime.awrap(mkdirpAsync(indexPath));

                                    case 6:
                                        context$3$0.next = 8;
                                        return _regeneratorRuntime.awrap(_fs2['default'].writeFileAsync(_path2['default'].join(indexPath, 'index.html'), indexContent));

                                    case 8:
                                        console.log(clc.info(lang + '/index file successfully created'));

                                    case 9:
                                    case 'end':
                                        return context$3$0.stop();
                                }
                            }, null, _this3);
                        })));

                    case 4:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }, {
        key: 'copyThemeResources',
        value: function copyThemeResources() {
            return _regeneratorRuntime.async(function copyThemeResources$(context$2$0) {
                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        context$2$0.next = 2;
                        return _regeneratorRuntime.awrap(ncpAsync(_path2['default'].join(this.theme.themePath, 'resources'), _path2['default'].join(this.sitePath, 'public'), { stopOnErr: true }));

                    case 2:
                        console.log(clc.info('Theme resources copied'));

                    case 3:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }, {
        key: 'copyUserResources',
        value: function copyUserResources() {
            var userResourcesPath;
            return _regeneratorRuntime.async(function copyUserResources$(context$2$0) {
                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        userResourcesPath = _path2['default'].join(this.sitePath, 'resources');
                        context$2$0.next = 3;
                        return _regeneratorRuntime.awrap(mkdirpAsync(userResourcesPath));

                    case 3:
                        context$2$0.next = 5;
                        return _regeneratorRuntime.awrap(ncpAsync(userResourcesPath, _path2['default'].join(this.sitePath, 'public'), { stopOnErr: true }));

                    case 5:
                        console.log(clc.info('User resources copied'));

                    case 6:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }, {
        key: 'generatePosts',
        value: function generatePosts(files) {
            var _ref7;

            var langs, config, posts, currentDate, nunjucksEnv, postsTemplate, postsTemplateNJ, tokens;
            return _regeneratorRuntime.async(function generatePosts$(context$2$0) {
                var _this4 = this;

                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        langs = _Object$keys(files);
                        config = this.config;
                        posts = {};
                        currentDate = new Date();
                        nunjucksEnv = this.nunjucksEnv;
                        postsTemplate = this.theme.getFileContents('post.html');
                        postsTemplateNJ = _nunjucks2['default'].compile(postsTemplate, nunjucksEnv);
                        tokens = [config.header_tokens ? config.header_tokens[0] : '<!--', config.header_tokens ? config.header_tokens[1] : '-->'];
                        context$2$0.next = 10;
                        return _regeneratorRuntime.awrap(_Promise.all((_ref7 = []).concat.apply(_ref7, _toConsumableArray(langs.map(function (lang) {
                            return files[lang].map(function callee$3$0(file) {
                                var metadata, post, postCropped, filename, checkDate, postPath, categories, _post, postHTMLFile, postDate, month, year, options, md;

                                return _regeneratorRuntime.async(function callee$3$0$(context$4$0) {
                                    while (1) switch (context$4$0.prev = context$4$0.next) {
                                        case 0:
                                            metadata = undefined, post = undefined, postCropped = undefined, filename = undefined, checkDate = undefined, postPath = undefined, categories = undefined, _post = undefined, postHTMLFile = undefined, postDate = undefined, month = undefined, year = undefined, options = undefined, md = new _markedMetadata2['default'](_path2['default'].join(this.sitePath, _config.postspath, lang, file));

                                            md.defineTokens(tokens[0], tokens[1]);
                                            metadata = Helper.normalizeMetaData(md.metadata());
                                            post = Helper.normalizeContent(md.markdown());
                                            postCropped = md.markdown({
                                                crop: '<!--more-->'
                                            });

                                            filename = _path2['default'].extname(file) === '.md' ? _path2['default'].basename(file, '.md') : _path2['default'].basename(file, '.markdown');

                                            checkDate = new Date(filename.substr(0, 10));

                                            filename = isNaN(checkDate.getDate()) ? filename : filename.substr(11, filename.length);

                                            postPath = null;
                                            categories = metadata.categories.split(',');
                                            postDate = new Date(metadata.date);
                                            year = postDate.getFullYear();
                                            month = ('0' + (postDate.getMonth() + 1)).slice(-2);

                                            // If is the default language, generate in the root path
                                            options = {
                                                replacements: [{
                                                    pattern: ':year',
                                                    replacement: year
                                                }, {
                                                    pattern: ':month',
                                                    replacement: month
                                                }, {
                                                    pattern: ':title',
                                                    replacement: filename
                                                }, {
                                                    pattern: ':language',
                                                    replacement: lang
                                                }]
                                            };
                                            if (config.i18n['default'] === lang && config.posts_permalink.match(':language')) {
                                                options.structure = config.posts_permalink.split(':language/')[1];
                                                postPath = (0, _permalinks2['default'])(options);
                                            } else {
                                                options.structure = config.posts_permalink;
                                                postPath = (0, _permalinks2['default'])(options);
                                            }

                                            metadata.categories = categories;
                                            metadata.content = postCropped;
                                            metadata.file = _config.postspath + file;
                                            metadata.filename = filename;
                                            metadata.link = postPath;
                                            metadata.lang = lang;
                                            metadata.default_lang = config.i18n['default'] === lang ? false : true;
                                            metadata.date = new Date(metadata.date);

                                            _post = {
                                                content: post,
                                                metadata: metadata
                                            };

                                            postHTMLFile = postsTemplateNJ.render({
                                                post: _post,
                                                config: config
                                            }).replace(/<!--[\s\S]*?-->/g, '');

                                            if (!(metadata.published && metadata.published === 'false')) {
                                                context$4$0.next = 27;
                                                break;
                                            }

                                            return context$4$0.abrupt('return');

                                        case 27:
                                            if (!(metadata.date && metadata.date > currentDate)) {
                                                context$4$0.next = 30;
                                                break;
                                            }

                                            console.log(clc.info('Skipping future post ' + metadata.filename));
                                            return context$4$0.abrupt('return');

                                        case 30:
                                            context$4$0.next = 32;
                                            return _regeneratorRuntime.awrap(mkdirpAsync(_path2['default'].join(this.sitePath, 'public', postPath)));

                                        case 32:
                                            context$4$0.next = 34;
                                            return _regeneratorRuntime.awrap(_fs2['default'].writeFileAsync(_path2['default'].join(this.sitePath, 'public', postPath, 'index.html'), postHTMLFile));

                                        case 34:
                                            console.log(clc.info('Successfully generated post ' + postPath));

                                            posts[lang] = posts[lang] || [];
                                            posts[lang].push(metadata);

                                        case 37:
                                        case 'end':
                                            return context$4$0.stop();
                                    }
                                }, null, _this4);
                            });
                        })))));

                    case 10:
                        return context$2$0.abrupt('return', Helper.sortPosts(posts));

                    case 11:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }, {
        key: 'generatePages',
        value: function generatePages(files) {
            var _ref8;

            var langs, config, pages, tokens;
            return _regeneratorRuntime.async(function generatePages$(context$2$0) {
                var _this5 = this;

                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        langs = _Object$keys(files);
                        config = this.config;
                        pages = {};
                        tokens = [config.header_tokens ? config.header_tokens[0] : '<!--', config.header_tokens ? config.header_tokens[1] : '-->'];
                        context$2$0.next = 6;
                        return _regeneratorRuntime.awrap(_Promise.all((_ref8 = []).concat.apply(_ref8, _toConsumableArray(langs.map(function (lang) {
                            return files[lang].map(function callee$3$0(file) {
                                var metadata, pagePermalink, _page, pageHTMLFile, options, pagePath, pageTpl, pageTplNJ, md, pageSrc, filename;

                                return _regeneratorRuntime.async(function callee$3$0$(context$4$0) {
                                    while (1) switch (context$4$0.prev = context$4$0.next) {
                                        case 0:
                                            metadata = undefined, pagePermalink = undefined, _page = undefined, pageHTMLFile = undefined, options = undefined, pagePath = _path2['default'].join(this.sitePath, _config.pagespath, lang, file), pageTpl = this.theme.getFileContents('page.html'), pageTplNJ = _nunjucks2['default'].compile(pageTpl, this.nunjucksEnv), md = new _markedMetadata2['default'](pagePath), pageSrc = '', filename = _path2['default'].extname(file) === '.md' ? _path2['default'].basename(file, '.md') : _path2['default'].basename(file, '.markdown');

                                            md.defineTokens(tokens[0], tokens[1]);

                                            // Markdown extra
                                            metadata = md.metadata();

                                            options = {
                                                replacements: [{
                                                    pattern: ':title',
                                                    replacement: filename
                                                }, {
                                                    pattern: ':language',
                                                    replacement: lang
                                                }]
                                            };
                                            if (config.i18n['default'] === lang) {
                                                options.structure = config.pages_permalink.split(':language/')[1];
                                                pagePermalink = (0, _permalinks2['default'])(options);
                                            } else {
                                                options.structure = config.pages_permalink;
                                                pagePermalink = (0, _permalinks2['default'])(options);
                                            }

                                            _page = {
                                                content: md.markdown(),
                                                metadata: metadata
                                            };

                                            pageHTMLFile = pageTplNJ.render({
                                                page: _page,
                                                config: config
                                            });

                                            // Removing header metadata
                                            pageHTMLFile = pageHTMLFile.replace(/<!--[\s\S]*?-->/g, '');

                                            metadata.content = pageHTMLFile;
                                            metadata.file = _config.postspath + file; // TODO check whether this needs sitePath
                                            metadata.filename = filename;
                                            metadata.link = pagePermalink;
                                            metadata.lang = lang;
                                            metadata.date = new Date(metadata.date);
                                            pageSrc = _path2['default'].join(this.sitePath, 'public', pagePermalink, 'index.html');

                                            context$4$0.next = 17;
                                            return _regeneratorRuntime.awrap(mkdirpAsync(_path2['default'].join(this.sitePath, 'public', pagePermalink)));

                                        case 17:
                                            context$4$0.next = 19;
                                            return _regeneratorRuntime.awrap(_fs2['default'].writeFileAsync(pageSrc, pageHTMLFile));

                                        case 19:
                                            console.log(clc.info('Successfully generated page ' + pagePermalink));

                                            pages[lang] = pages[lang] || [];
                                            pages[lang].push(metadata);

                                        case 22:
                                        case 'end':
                                            return context$4$0.stop();
                                    }
                                }, null, _this5);
                            });
                        })))));

                    case 6:
                        return context$2$0.abrupt('return', pages);

                    case 7:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }, {
        key: 'getPostFiles',
        value: function getPostFiles() {
            var files;
            return _regeneratorRuntime.async(function getPostFiles$(context$2$0) {
                var _this6 = this;

                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        files = {};
                        context$2$0.next = 3;
                        return _regeneratorRuntime.awrap(_Promise.all(this.config.i18n.languages.map(function callee$2$0(lang) {
                            return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
                                while (1) switch (context$3$0.prev = context$3$0.next) {
                                    case 0:
                                        context$3$0.next = 2;
                                        return _regeneratorRuntime.awrap(_fs2['default'].readdirAsync(_path2['default'].join(this.sitePath, _config.postspath, lang)));

                                    case 2:
                                        context$3$0.t0 = function (p) {
                                            return rMarkdownExt.test(p);
                                        };

                                        files[lang] = context$3$0.sent.filter(context$3$0.t0);

                                    case 4:
                                    case 'end':
                                        return context$3$0.stop();
                                }
                            }, null, _this6);
                        })));

                    case 3:
                        return context$2$0.abrupt('return', files);

                    case 4:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }, {
        key: 'getPageFiles',
        value: function getPageFiles() {
            var files;
            return _regeneratorRuntime.async(function getPageFiles$(context$2$0) {
                var _this7 = this;

                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        files = {};
                        context$2$0.next = 3;
                        return _regeneratorRuntime.awrap(_Promise.all(this.config.i18n.languages.map(function callee$2$0(lang) {
                            var langPath;
                            return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
                                while (1) switch (context$3$0.prev = context$3$0.next) {
                                    case 0:
                                        langPath = _path2['default'].join(this.sitePath, _config.pagespath, lang);
                                        context$3$0.next = 3;
                                        return _regeneratorRuntime.awrap(mkdirpAsync(langPath));

                                    case 3:
                                        context$3$0.next = 5;
                                        return _regeneratorRuntime.awrap(_fs2['default'].readdirAsync(langPath));

                                    case 5:
                                        context$3$0.t0 = function (p) {
                                            return rMarkdownExt.test(p);
                                        };

                                        files[lang] = context$3$0.sent.filter(context$3$0.t0);

                                    case 7:
                                    case 'end':
                                        return context$3$0.stop();
                                }
                            }, null, _this7);
                        })));

                    case 3:
                        return context$2$0.abrupt('return', files);

                    case 4:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }, {
        key: 'generateRSS',
        value: function generateRSS(postsMetadata, pagesMetadata) {
            var rssTemplate, rssTemplateNJ, config, rssAuthor;
            return _regeneratorRuntime.async(function generateRSS$(context$2$0) {
                var _this8 = this;

                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        context$2$0.next = 2;
                        return _regeneratorRuntime.awrap(_fs2['default'].readFileAsync(_path2['default'].join(__dirname, 'resources/rss.xml'), { encoding: 'utf8' }));

                    case 2:
                        rssTemplate = context$2$0.sent;
                        rssTemplateNJ = _nunjucks2['default'].compile(rssTemplate, this.nunjucksEnv);
                        config = this.config;
                        rssAuthor = config.author_email ? config.author_email + ' ( ' + config.author + ' )' : config.author;
                        context$2$0.next = 8;
                        return _regeneratorRuntime.awrap(_Promise.all(_Object$entries(postsMetadata).map(function callee$2$0(_ref9) {
                            var _ref92 = _slicedToArray(_ref9, 2);

                            var lang = _ref92[0];
                            var langPosts = _ref92[1];
                            var posts, isDefaultLang, rssPath, rssLink, rssContent;
                            return _regeneratorRuntime.async(function callee$2$0$(context$3$0) {
                                while (1) switch (context$3$0.prev = context$3$0.next) {
                                    case 0:
                                        posts = langPosts.slice(0, config.index_posts);
                                        isDefaultLang = config.i18n['default'] === lang;
                                        rssPath = _path2['default'].join.apply(_path2['default'], [this.sitePath, 'public'].concat(_toConsumableArray(isDefaultLang ? [] : [lang])));
                                        rssLink = '' + config.domain + (isDefaultLang ? '' : '/' + lang) + '/rss.xml';
                                        rssContent = rssTemplateNJ.render({
                                            rss: {
                                                date: new Date().toUTCString(),
                                                link: rssLink,
                                                author: rssAuthor,
                                                lang: lang
                                            },
                                            posts: posts,
                                            config: config,
                                            pages: pagesMetadata
                                        });
                                        context$3$0.next = 7;
                                        return _regeneratorRuntime.awrap(mkdirpAsync(rssPath));

                                    case 7:
                                        context$3$0.next = 9;
                                        return _regeneratorRuntime.awrap(_fs2['default'].writeFileAsync(rssPath + '/rss.xml', rssContent));

                                    case 9:
                                        console.log(clc.info(lang + '/rss.xml file successfully created'));

                                    case 10:
                                    case 'end':
                                        return context$3$0.stop();
                                }
                            }, null, _this8);
                        })));

                    case 8:
                    case 'end':
                        return context$2$0.stop();
                }
            }, null, this);
        }
    }]);

    return Harmonic;
})();

exports['default'] = Harmonic;
module.exports = exports['default'];

// TODO this can most likely do with some refactoring and code style adjustments

// write post html file

// TODO this can most likely do with some refactoring and code style adjustments

// write page html file